function HandleToggleCommand(Split, Player)
	if (Player:HasPermission("portal.create") == true) then
		if (PlayersData[Player:GetName()] == nil) then
			PlayersData[Player:GetName()] = {}	-- create player's page
		end
		if (PlayersData[Player:GetName()].create_volume_mode == nil) then
			PlayersData[Player:GetName()].create_volume_mode = false
		end
		if (PlayersData[Player:GetName()].create_volume_mode == false) then
			PlayersData[Player:GetName()].create_volume_mode = true
			Player:SendMessage("Your wooden sword will now select portal entrance zone")
		else
			PlayersData[Player:GetName()].create_volume_mode = false
			Player:SendMessage("Your wooden sword will now act as usual")
		end
	end
	return true
end

function HandleMakeWarpCommand(Split, Player)
	if (Player:HasPermission("portal.create") == true) then
		if (#Split == 2) then
			if (PortalsData.warps[Split[2]] == nil) then
				PortalsData.warps[Split[2]] = {}	-- we create a new warp note
				PortalsData.warps[Split[2]].world_name = Player:GetWorld():GetName()
				PortalsData.warps[Split[2]].x = Player:GetPosX()
				PortalsData.warps[Split[2]].y = Player:GetPosY()
				PortalsData.warps[Split[2]].z = Player:GetPosZ()
				Player:SendMessage('Warp "'..Split[2]..'" created!')
				
				CheckLinkage(true, Split[2], Player)
				SavePortalsData()
			else
				Player:SendMessage('There already is a warp, named "'..Split[2]..'"')
			end
		end
	else
		Player:SendMessage("You're not allowed to create warps")
	end
	return true
end

function HandleMakeEnterCommand(Split, Player)
	Player:SendMessage("Step 0: good")
	if (Player:HasPermission("portal.create") == true) then
		if (#Split == 2) then
			Player:SendMessage("Step 1: good")
			if (PlayersData[Player:GetName()].point1 ~= nil) then
				Player:SendMessage("Step 2: good")
				if (PlayersData[Player:GetName()].point2 ~= nil) then
					Player:SendMessage("Step 3: good")
					if (PortalsData.enters[Split[2]] == nil) then
						PortalsData.enters[Split[2]] = {}	-- we create a new enter note
						PortalsData.enters[Split[2]].point1 = Vector3i()
						PortalsData.enters[Split[2]].point2 = Vector3i()
						PortalsData.enters[Split[2]].point1 = PlayersData[Player:GetName()].point1
						PortalsData.enters[Split[2]].point2 = PlayersData[Player:GetName()].point2
						Player:SendMessage('Entrance "'..Split[2]..'" created!')
						
						CheckLinkage(false, Split[2], Player)
						SavePortalsData()
					else
						Player:SendMessage('There already is an entrance, named "'..Split[2]..'"')
					end
				else
					Player:SendMessage("You haven't specified the portal entrance zone!")
				end
			end
		end
	else
		Player:SendMessage("You're not allowed to create portals")
	end
	return Content
end

function SavePortalsData()
end

function CheckLinkage(ForWarp, CheckName, Player)
	if (ForWarp) then
		if (PortalsData.enters[CheckName] == nil) then
			Player:SendMessage("Now you should create portal entrance")
		else
			PortalsData.enters[CheckName].linked = true
			Player:SendMessage('Portal "'..CheckName..'" is linked!')
			LOG('Portal "'..CheckName..'" is linked!')
		end
	else
		if (PortalsData.warps[CheckName] == nil) then
			Player:SendMessage("Now you should mark portal warp point")
		else
			PortalsData.enters[CheckName].linked = true
			Player:SendMessage('Portal "'..CheckName..'" is linked!')
			LOG('Portal "'..CheckName..'" is linked!')
		end
	end
end

function FindZone(Player)
	local _check_cuboid = cCuboid()
	local _player_pos = Player:GetPosition()
	for k,v in pairs(PortalsData.enters) do
		if (v.linked) then
			_check_cuboid.p1 = v.point1
			_check_cuboid.p2 = v.point2
			if (_check_cuboid:IsInside(_player_pos)) then
				return k
			end
		end
	end
	return false
end